#ifndef MARS_MCalibColorSteer
#define MARS_MCalibColorSteer

#ifndef MARS_MTask
#include "MTask.h"
#endif

class MParList;
class MGeomCam;
class MCalibrationPattern;
class MRawRunHeader;
class MRawEvtHeader;
class MCalibrationChargeCalc;
class MCalibrationRelTimeCalc;
class MCalibrationIntensityChargeCam;
class MCalibrationIntensityBlindCam;
class MCalibrationIntensityQECam;
class MCalibrationIntensityRelTimeCam;
class MBadPixelsIntensityCam;
class MBadPixelsCam;
class MCalibColorSteer : public MTask
{
private:


  MCalibrationPattern             *fCalibPattern;    //!
  MRawEvtHeader                   *fEvtHeader;       //!
  MRawRunHeader                   *fRunHeader;       //!
  MGeomCam                        *fGeom;            //!
  MParList                        *fParList;         //!
  MCalibrationIntensityChargeCam  *fIntensCharge;    //!
  MCalibrationIntensityBlindCam   *fIntensBlind;     //!  
  MCalibrationIntensityQECam      *fIntensQE;        //!
  MCalibrationIntensityRelTimeCam *fIntensRelTime;   //!
  MBadPixelsIntensityCam          *fIntensBad;       //!
  MBadPixelsCam                   *fBad;             //!
  
  MCalibrationChargeCalc          *fChargeCalc;      //!
  MCalibrationRelTimeCalc         *fRelTimeCalc;     //!
                                                     
  UInt_t fPattern;                                   
  
  Int_t  PreProcess(MParList *pList);
  Int_t  Process();
  
  Bool_t ReInitialize();
  Bool_t Finalize(const char* name);
  TString GetNamePattern();
  
public:

    MCalibColorSteer(const char *name=NULL, const char *title=NULL);
    ~MCalibColorSteer() {}

    ClassDef(MCalibColorSteer, 1) // Task to steer the processing of multiple calibration colours
};
    
#endif

